=== debian/changelog ===
openiked (7.3-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:06:59 +1100

openiked (7.3-1build2) noble; urgency=medium

  * No-change rebuild against libevent-2.1-7t64

 -- Simon Chopin <schopin@ubuntu.com>  Fri, 29 Mar 2024 17:28:35 +0100

openiked (7.3-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 20:30:35 +0000

openiked (7.3-1) unstable; urgency=medium

  * New upstream release
  * Update copyright holders
  * Bump standards version, no changes required
  * Enable systemd-resolved support
  * Enable apparmor support

 -- Ryan Kavanagh <rak@debian.org>  Wed, 22 Nov 2023 13:14:40 -0500
