=== debian/control ===
Source: openiked
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Ryan Kavanagh <rak@debian.org>
Uploaders: Tobias Heider <me@tobhe.de>
Build-Depends: bison,
               cmake,
               debhelper-compat (= 13),
               libapparmor-dev,
               libevent-dev,
               libssl-dev,
               libsystemd-dev,
Standards-Version: 4.6.2
Homepage: https://www.openiked.org/
Vcs-Browser: https://salsa.debian.org/debian/openiked
Vcs-Git: https://salsa.debian.org/debian/openiked.git -b debian/unstable
Rules-Requires-Root: no

Package: openiked
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser,
         openssl,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Internet Key Exchange (IKEv2) daemon
 A free implementation of the Internet Key Exchange (IKEv2) protocol
 which performs mutual authentication and which establishes and maintains
 IPsec VPN security policies and associations (SAs) between peers. It is
 intended to be a lean, clean, secure, better configurable and
 interoperable implementation that focusses on supporting the main
 standards and most important features of IKEv2.
