## openiked 7.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -36,11 +36,11 @@
 	if (HOMEBREW AND CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "arm64")
 		include_directories("/opt/homebrew/include")
 		link_directories("/opt/homebrew/lib")
-		include_directories("/opt/homebrew/opt/openssl@1.1/include")
-        	link_directories("/opt/homebrew/opt/openssl@1.1/lib")
+		include_directories("/opt/homebrew/opt/openssl/include")
+        	link_directories("/opt/homebrew/opt/openssl/lib")
 	else()
-		include_directories("/usr/local/opt/openssl@1.1/include")
-		link_directories("/usr/local/opt/openssl@1.1/lib")
+		include_directories("/usr/local/opt/openssl/include")
+		link_directories("/usr/local/opt/openssl/lib")
 	endif()
 	set(HAVE_VROUTE ON)
 elseif(CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
@@ -82,6 +82,9 @@
 if (NOT DEFINED CMAKE_INSTALL_MANDIR)
 	set (CMAKE_INSTALL_MANDIR ${CMAKE_INSTALL_PREFIX}/man)
 endif()
+if (NOT DEFINED CMAKE_INSTALL_SBINDIR)
+	set (CMAKE_INSTALL_SBINDIR ${CMAKE_INSTALL_PREFIX}/sbin)
+endif()
 
 check_linker_flag(C "LINKER:-z,now,-z,relro" HAVE_LD_Z)
 
@@ -362,17 +365,9 @@
         add_definitions(-DHAVE_GETOPT)
 endif()
 
-check_function_exists(ibuf_add_buf HAVE_IBUF_ADD_BUF)
-if(HAVE_IBUF_ADD_BUF)
-        add_definitions(-DHAVE_IBUF_ADD_BUF)
-endif()
-check_function_exists(ibuf_add_zero HAVE_IBUF_ADD_ZERO)
-if(HAVE_IBUF_ADD_ZERO)
-        add_definitions(-DHAVE_IBUF_ADD_ZERO)
-endif()
-check_function_exists(ibuf_data HAVE_IBUF_DATA)
-if(HAVE_IBUF_DATA)
-        add_definitions(-DHAVE_IBUF_DATA)
+check_function_exists(msgbuf_new_reader HAVE_MSGBUF_NEW_READER)
+if(HAVE_MSGBUF_NEW_READER)
+        add_definitions(-DHAVE_MSGBUF_NEW_READER)
 endif()
 
 if(HAVE_VROUTE OR HAVE_VROUTE_NETLINK)
@@ -406,7 +401,7 @@
 	add_subdirectory(regress/parser-libfuzzer)
 	if (NOT DEFINED ENV{CLUSTERFUZZLITE})
 		set(CMAKE_C_COMPILER clang)
-		string(APPEND CMAKE_C_FLAGS " -g -O1 -fsanitize=fuzzer-no-link")
+		string(APPEND CMAKE_C_FLAGS " -g -O0 -fsanitize=fuzzer-no-link")
 	endif()
 endif()
 add_subdirectory(compat)
