=== iked/CMakeLists.txt ===
--- 
+++ 
@@ -161,7 +161,7 @@
 	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/genmap.sh
 )
 
-install(TARGETS iked RUNTIME DESTINATION sbin)
+install(TARGETS iked RUNTIME DESTINATION ${CMAKE_INSTALL_SBINDIR})
 install(FILES ${CMAKE_SOURCE_DIR}/iked.conf
 	PERMISSIONS OWNER_READ OWNER_WRITE 
 	DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}
@@ -169,7 +169,7 @@
 install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/iked.conf.5 DESTINATION ${CMAKE_INSTALL_MANDIR}/man5/)
 install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/iked.8 DESTINATION ${CMAKE_INSTALL_MANDIR}/man8/)
 if(WITH_APPARMOR)
-	install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/../contrib/iked.apparmor
+	install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/../linux/iked.apparmor
 		DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/apparmor.d/
 		RENAME usr.sbin.iked)
 endif()
