=== debian/changelog ===
openiked (7.4-1) unstable; urgency=medium

  * New upstream version 7.4
  * Update d/copyright
  * d/gbp.conf: add upstream branch
  * Bump standards to 4.7.2, no changes required
  * d/p/0001-run-iked.sock-moves-to-control-process-after-recent-.patch:
    - apparmor: allow control process r/w access to /run/iked.sock

 -- Tobias Heider <me@tobhe.de>  Sun, 13 Apr 2025 21:06:19 +0200
