=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: openiked
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Ryan Kavanagh <rak@debian.org>
+Maintainer: Ryan Kavanagh <rak@debian.org>
 Uploaders: Tobias Heider <me@tobhe.de>
 Build-Depends: bison,
                cmake,
@@ -11,7 +10,7 @@
                libevent-dev,
                libssl-dev,
                libsystemd-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://www.openiked.org/
 Vcs-Browser: https://salsa.debian.org/debian/openiked
 Vcs-Git: https://salsa.debian.org/debian/openiked.git -b debian/unstable
