=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts="pgpmode=auto" \
    https://ftp.openbsd.org/pub/OpenBSD/OpenIKED/openiked-(\d[\d.]*)\.tar\.gz
